Merge branch 'ep/maint-equals-null-cocci'
[git/debian.git] / t / test-lib.sh
blobf09e8f3efceb4f13ebea942d01cd4ad90d969bda
1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Test the binaries we have just built. The tests are kept in
19 # t/ subdirectory and are run in 'trash directory' subdirectory.
20 if test -z "$TEST_DIRECTORY"
21 then
22 # ensure that TEST_DIRECTORY is an absolute path so that it
23 # is valid even if the current working directory is changed
24 TEST_DIRECTORY=$(pwd)
25 else
26 # The TEST_DIRECTORY will always be the path to the "t"
27 # directory in the git.git checkout. This is overridden by
28 # e.g. t/lib-subtest.sh, but only because its $(pwd) is
29 # different. Those tests still set "$TEST_DIRECTORY" to the
30 # same path.
32 # See use of "$GIT_BUILD_DIR" and "$TEST_DIRECTORY" below for
33 # hard assumptions about "$GIT_BUILD_DIR/t" existing and being
34 # the "$TEST_DIRECTORY", and e.g. "$TEST_DIRECTORY/helper"
35 # needing to exist.
36 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
38 if test -z "$TEST_OUTPUT_DIRECTORY"
39 then
40 # Similarly, override this to store the test-results subdir
41 # elsewhere
42 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
44 GIT_BUILD_DIR="${TEST_DIRECTORY%/t}"
45 if test "$TEST_DIRECTORY" = "$GIT_BUILD_DIR"
46 then
47 echo "PANIC: Running in a $TEST_DIRECTORY that doesn't end in '/t'?" >&2
48 exit 1
51 # Prepend a string to a VAR using an arbitrary ":" delimiter, not
52 # adding the delimiter if VAR or VALUE is empty. I.e. a generalized:
54 # VAR=$1${VAR:+${1:+$2}$VAR}
56 # Usage (using ":" as the $2 delimiter):
58 # prepend_var VAR : VALUE
59 prepend_var () {
60 eval "$1=$3\${$1:+${3:+$2}\$$1}"
63 # If [AL]SAN is in effect we want to abort so that we notice
64 # problems. The GIT_SAN_OPTIONS variable can be used to set common
65 # defaults shared between [AL]SAN_OPTIONS.
66 prepend_var GIT_SAN_OPTIONS : abort_on_error=1
67 prepend_var GIT_SAN_OPTIONS : strip_path_prefix=\"$GIT_BUILD_DIR/\"
69 # If we were built with ASAN, it may complain about leaks
70 # of program-lifetime variables. Disable it by default to lower
71 # the noise level. This needs to happen at the start of the script,
72 # before we even do our "did we build git yet" check (since we don't
73 # want that one to complain to stderr).
74 prepend_var ASAN_OPTIONS : $GIT_SAN_OPTIONS
75 prepend_var ASAN_OPTIONS : detect_leaks=0
76 export ASAN_OPTIONS
78 prepend_var LSAN_OPTIONS : $GIT_SAN_OPTIONS
79 prepend_var LSAN_OPTIONS : fast_unwind_on_malloc=0
80 export LSAN_OPTIONS
82 if test ! -f "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
83 then
84 echo >&2 'error: GIT-BUILD-OPTIONS missing (has Git been built?).'
85 exit 1
87 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
88 export PERL_PATH SHELL_PATH
90 # In t0000, we need to override test directories of nested testcases. In case
91 # the developer has TEST_OUTPUT_DIRECTORY part of his build options, then we'd
92 # reset this value to instead contain what the developer has specified. We thus
93 # have this knob to allow overriding the directory.
94 if test -n "${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
95 then
96 TEST_OUTPUT_DIRECTORY="${TEST_OUTPUT_DIRECTORY_OVERRIDE}"
99 # Disallow the use of abbreviated options in the test suite by default
100 if test -z "${GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS}"
101 then
102 GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS=true
103 export GIT_TEST_DISALLOW_ABBREVIATED_OPTIONS
106 # Explicitly set the default branch name for testing, to avoid the
107 # transitory "git init" warning under --verbose.
108 : ${GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME:=master}
109 export GIT_TEST_DEFAULT_INITIAL_BRANCH_NAME
111 ################################################################
112 # It appears that people try to run tests without building...
113 "${GIT_TEST_INSTALLED:-$GIT_BUILD_DIR}/git$X" >/dev/null
114 if test $? != 1
115 then
116 if test -n "$GIT_TEST_INSTALLED"
117 then
118 echo >&2 "error: there is no working Git at '$GIT_TEST_INSTALLED'"
119 else
120 echo >&2 'error: you do not seem to have built git yet.'
122 exit 1
125 store_arg_to=
126 opt_required_arg=
127 # $1: option string
128 # $2: name of the var where the arg will be stored
129 mark_option_requires_arg () {
130 if test -n "$opt_required_arg"
131 then
132 echo "error: options that require args cannot be bundled" \
133 "together: '$opt_required_arg' and '$1'" >&2
134 exit 1
136 opt_required_arg=$1
137 store_arg_to=$2
140 parse_option () {
141 local opt="$1"
143 case "$opt" in
144 -d|--d|--de|--deb|--debu|--debug)
145 debug=t ;;
146 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
147 immediate=t ;;
148 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
149 GIT_TEST_LONG=t; export GIT_TEST_LONG ;;
151 mark_option_requires_arg "$opt" run_list
153 --run=*)
154 run_list=${opt#--*=} ;;
155 -h|--h|--he|--hel|--help)
156 help=t ;;
157 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
158 verbose=t ;;
159 --verbose-only=*)
160 verbose_only=${opt#--*=}
162 -q|--q|--qu|--qui|--quie|--quiet)
163 # Ignore --quiet under a TAP::Harness. Saying how many tests
164 # passed without the ok/not ok details is always an error.
165 test -z "$HARNESS_ACTIVE" && quiet=t ;;
166 --with-dashes)
167 with_dashes=t ;;
168 --no-bin-wrappers)
169 no_bin_wrappers=t ;;
170 --no-color)
171 color= ;;
172 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
173 valgrind=memcheck
174 tee=t
176 --valgrind=*)
177 valgrind=${opt#--*=}
178 tee=t
180 --valgrind-only=*)
181 valgrind_only=${opt#--*=}
182 tee=t
184 --tee)
185 tee=t ;;
186 --root=*)
187 root=${opt#--*=} ;;
188 --chain-lint)
189 GIT_TEST_CHAIN_LINT=1 ;;
190 --no-chain-lint)
191 GIT_TEST_CHAIN_LINT=0 ;;
193 trace=t ;;
194 -V|--verbose-log)
195 verbose_log=t
196 tee=t
198 --write-junit-xml)
199 write_junit_xml=t
201 --stress)
202 stress=t ;;
203 --stress=*)
204 echo "error: --stress does not accept an argument: '$opt'" >&2
205 echo "did you mean --stress-jobs=${opt#*=} or --stress-limit=${opt#*=}?" >&2
206 exit 1
208 --stress-jobs=*)
209 stress=t;
210 stress_jobs=${opt#--*=}
211 case "$stress_jobs" in
212 *[!0-9]*|0*|"")
213 echo "error: --stress-jobs=<N> requires the number of jobs to run" >&2
214 exit 1
216 *) # Good.
218 esac
220 --stress-limit=*)
221 stress=t;
222 stress_limit=${opt#--*=}
223 case "$stress_limit" in
224 *[!0-9]*|0*|"")
225 echo "error: --stress-limit=<N> requires the number of repetitions" >&2
226 exit 1
228 *) # Good.
230 esac
233 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
234 esac
237 # Parse options while taking care to leave $@ intact, so we will still
238 # have all the original command line options when executing the test
239 # script again for '--tee' and '--verbose-log' later.
240 for opt
242 if test -n "$store_arg_to"
243 then
244 eval $store_arg_to=\$opt
245 store_arg_to=
246 opt_required_arg=
247 continue
250 case "$opt" in
251 --*|-?)
252 parse_option "$opt" ;;
253 -?*)
254 # bundled short options must be fed separately to parse_option
255 opt=${opt#-}
256 while test -n "$opt"
258 extra=${opt#?}
259 this=${opt%$extra}
260 opt=$extra
261 parse_option "-$this"
262 done
265 echo "error: unknown test option '$opt'" >&2; exit 1 ;;
266 esac
267 done
268 if test -n "$store_arg_to"
269 then
270 echo "error: $opt_required_arg requires an argument" >&2
271 exit 1
274 if test -n "$valgrind_only"
275 then
276 test -z "$valgrind" && valgrind=memcheck
277 test -z "$verbose" && verbose_only="$valgrind_only"
278 elif test -n "$valgrind"
279 then
280 test -z "$verbose_log" && verbose=t
283 if test -n "$stress"
284 then
285 verbose=t
286 trace=t
287 immediate=t
290 TEST_STRESS_JOB_SFX="${GIT_TEST_STRESS_JOB_NR:+.stress-$GIT_TEST_STRESS_JOB_NR}"
291 TEST_NAME="$(basename "$0" .sh)"
292 TEST_NUMBER="${TEST_NAME%%-*}"
293 TEST_NUMBER="${TEST_NUMBER#t}"
294 TEST_RESULTS_DIR="$TEST_OUTPUT_DIRECTORY/test-results"
295 TEST_RESULTS_BASE="$TEST_RESULTS_DIR/$TEST_NAME$TEST_STRESS_JOB_SFX"
296 TRASH_DIRECTORY="trash directory.$TEST_NAME$TEST_STRESS_JOB_SFX"
297 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
298 case "$TRASH_DIRECTORY" in
299 /*) ;; # absolute path is good
300 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
301 esac
303 # If --stress was passed, run this test repeatedly in several parallel loops.
304 if test "$GIT_TEST_STRESS_STARTED" = "done"
305 then
306 : # Don't stress test again.
307 elif test -n "$stress"
308 then
309 if test -n "$stress_jobs"
310 then
311 job_count=$stress_jobs
312 elif test -n "$GIT_TEST_STRESS_LOAD"
313 then
314 job_count="$GIT_TEST_STRESS_LOAD"
315 elif job_count=$(getconf _NPROCESSORS_ONLN 2>/dev/null) &&
316 test -n "$job_count"
317 then
318 job_count=$((2 * $job_count))
319 else
320 job_count=8
323 mkdir -p "$TEST_RESULTS_DIR"
324 stressfail="$TEST_RESULTS_BASE.stress-failed"
325 rm -f "$stressfail"
327 stress_exit=0
328 trap '
329 kill $job_pids 2>/dev/null
330 wait
331 stress_exit=1
332 ' TERM INT HUP
334 job_pids=
335 job_nr=0
336 while test $job_nr -lt "$job_count"
339 GIT_TEST_STRESS_STARTED=done
340 GIT_TEST_STRESS_JOB_NR=$job_nr
341 export GIT_TEST_STRESS_STARTED GIT_TEST_STRESS_JOB_NR
343 trap '
344 kill $test_pid 2>/dev/null
345 wait
346 exit 1
347 ' TERM INT
349 cnt=1
350 while ! test -e "$stressfail" &&
351 { test -z "$stress_limit" ||
352 test $cnt -le $stress_limit ; }
354 $TEST_SHELL_PATH "$0" "$@" >"$TEST_RESULTS_BASE.stress-$job_nr.out" 2>&1 &
355 test_pid=$!
357 if wait $test_pid
358 then
359 printf "OK %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
360 else
361 echo $GIT_TEST_STRESS_JOB_NR >>"$stressfail"
362 printf "FAIL %2d.%d\n" $GIT_TEST_STRESS_JOB_NR $cnt
364 cnt=$(($cnt + 1))
365 done
367 job_pids="$job_pids $!"
368 job_nr=$(($job_nr + 1))
369 done
371 wait
373 if test -f "$stressfail"
374 then
375 stress_exit=1
376 echo "Log(s) of failed test run(s):"
377 for failed_job_nr in $(sort -n "$stressfail")
379 echo "Contents of '$TEST_RESULTS_BASE.stress-$failed_job_nr.out':"
380 cat "$TEST_RESULTS_BASE.stress-$failed_job_nr.out"
381 done
382 rm -rf "$TRASH_DIRECTORY.stress-failed"
383 # Move the last one.
384 mv "$TRASH_DIRECTORY.stress-$failed_job_nr" "$TRASH_DIRECTORY.stress-failed"
387 exit $stress_exit
390 # if --tee was passed, write the output not only to the terminal, but
391 # additionally to the file test-results/$BASENAME.out, too.
392 if test "$GIT_TEST_TEE_STARTED" = "done"
393 then
394 : # do not redirect again
395 elif test -n "$tee"
396 then
397 mkdir -p "$TEST_RESULTS_DIR"
399 # Make this filename available to the sub-process in case it is using
400 # --verbose-log.
401 GIT_TEST_TEE_OUTPUT_FILE=$TEST_RESULTS_BASE.out
402 export GIT_TEST_TEE_OUTPUT_FILE
404 # Truncate before calling "tee -a" to get rid of the results
405 # from any previous runs.
406 >"$GIT_TEST_TEE_OUTPUT_FILE"
408 (GIT_TEST_TEE_STARTED=done ${TEST_SHELL_PATH} "$0" "$@" 2>&1;
409 echo $? >"$TEST_RESULTS_BASE.exit") | tee -a "$GIT_TEST_TEE_OUTPUT_FILE"
410 test "$(cat "$TEST_RESULTS_BASE.exit")" = 0
411 exit
414 if test -n "$trace" && test -n "$test_untraceable"
415 then
416 # '-x' tracing requested, but this test script can't be reliably
417 # traced, unless it is run with a Bash version supporting
418 # BASH_XTRACEFD (introduced in Bash v4.1).
420 # Perform this version check _after_ the test script was
421 # potentially re-executed with $TEST_SHELL_PATH for '--tee' or
422 # '--verbose-log', so the right shell is checked and the
423 # warning is issued only once.
424 if test -n "$BASH_VERSION" && eval '
425 test ${BASH_VERSINFO[0]} -gt 4 || {
426 test ${BASH_VERSINFO[0]} -eq 4 &&
427 test ${BASH_VERSINFO[1]} -ge 1
430 then
431 : Executed by a Bash version supporting BASH_XTRACEFD. Good.
432 else
433 echo >&2 "warning: ignoring -x; '$0' is untraceable without BASH_XTRACEFD"
434 trace=
437 if test -n "$trace" && test -z "$verbose_log"
438 then
439 verbose=t
442 # Since bash 5.0, checkwinsize is enabled by default which does
443 # update the COLUMNS variable every time a non-builtin command
444 # completes, even for non-interactive shells.
445 # Disable that since we are aiming for repeatability.
446 test -n "$BASH_VERSION" && shopt -u checkwinsize 2>/dev/null
448 # For repeatability, reset the environment to known value.
449 # TERM is sanitized below, after saving color control sequences.
450 LANG=C
451 LC_ALL=C
452 PAGER=cat
453 TZ=UTC
454 COLUMNS=80
455 export LANG LC_ALL PAGER TZ COLUMNS
456 EDITOR=:
458 # A call to "unset" with no arguments causes at least Solaris 10
459 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
460 # deriving from the command substitution clustered with the other
461 # ones.
462 unset VISUAL EMAIL LANGUAGE $("$PERL_PATH" -e '
463 my @env = keys %ENV;
464 my $ok = join("|", qw(
465 TRACE
466 DEBUG
467 TEST
468 .*_TEST
469 PROVE
470 VALGRIND
471 UNZIP
472 PERF_
473 CURL_VERBOSE
474 TRACE_CURL
476 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
477 print join("\n", @vars);
479 unset XDG_CACHE_HOME
480 unset XDG_CONFIG_HOME
481 unset GITPERLLIB
482 unset GIT_TRACE2_PARENT_NAME
483 unset GIT_TRACE2_PARENT_SID
484 TEST_AUTHOR_LOCALNAME=author
485 TEST_AUTHOR_DOMAIN=example.com
486 GIT_AUTHOR_EMAIL=${TEST_AUTHOR_LOCALNAME}@${TEST_AUTHOR_DOMAIN}
487 GIT_AUTHOR_NAME='A U Thor'
488 GIT_AUTHOR_DATE='1112354055 +0200'
489 TEST_COMMITTER_LOCALNAME=committer
490 TEST_COMMITTER_DOMAIN=example.com
491 GIT_COMMITTER_EMAIL=${TEST_COMMITTER_LOCALNAME}@${TEST_COMMITTER_DOMAIN}
492 GIT_COMMITTER_NAME='C O Mitter'
493 GIT_COMMITTER_DATE='1112354055 +0200'
494 GIT_MERGE_VERBOSITY=5
495 GIT_MERGE_AUTOEDIT=no
496 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
497 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
498 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
499 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
500 export EDITOR
502 GIT_DEFAULT_HASH="${GIT_TEST_DEFAULT_HASH:-sha1}"
503 export GIT_DEFAULT_HASH
504 GIT_TEST_MERGE_ALGORITHM="${GIT_TEST_MERGE_ALGORITHM:-ort}"
505 export GIT_TEST_MERGE_ALGORITHM
507 # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output
508 GIT_TRACE_BARE=1
509 export GIT_TRACE_BARE
511 # Some tests scan the GIT_TRACE2_EVENT feed for events, but the
512 # default depth is 2, which frequently causes issues when the
513 # events are wrapped in new regions. Set it to a sufficiently
514 # large depth to avoid custom changes in the test suite.
515 GIT_TRACE2_EVENT_NESTING=100
516 export GIT_TRACE2_EVENT_NESTING
518 # Use specific version of the index file format
519 if test -n "${GIT_TEST_INDEX_VERSION:+isset}"
520 then
521 GIT_INDEX_VERSION="$GIT_TEST_INDEX_VERSION"
522 export GIT_INDEX_VERSION
525 if test -n "$GIT_TEST_PERL_FATAL_WARNINGS"
526 then
527 GIT_PERL_FATAL_WARNINGS=1
528 export GIT_PERL_FATAL_WARNINGS
531 case $GIT_TEST_FSYNC in
533 GIT_TEST_FSYNC=0
534 export GIT_TEST_FSYNC
536 esac
538 # Add libc MALLOC and MALLOC_PERTURB test only if we are not executing
539 # the test with valgrind and have not compiled with SANITIZE=address.
540 if test -n "$valgrind" ||
541 test -n "$SANITIZE_ADDRESS" ||
542 test -n "$TEST_NO_MALLOC_CHECK"
543 then
544 setup_malloc_check () {
545 : nothing
547 teardown_malloc_check () {
548 : nothing
550 else
551 setup_malloc_check () {
552 local g
553 local t
554 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
555 export MALLOC_CHECK_ MALLOC_PERTURB_
556 if _GLIBC_VERSION=$(getconf GNU_LIBC_VERSION 2>/dev/null) &&
557 _GLIBC_VERSION=${_GLIBC_VERSION#"glibc "} &&
558 expr 2.34 \<= "$_GLIBC_VERSION" >/dev/null
559 then
561 LD_PRELOAD="libc_malloc_debug.so.0"
562 for t in \
563 glibc.malloc.check=1 \
564 glibc.malloc.perturb=165
566 g="${g#:}:$t"
567 done
568 GLIBC_TUNABLES=$g
569 export LD_PRELOAD GLIBC_TUNABLES
572 teardown_malloc_check () {
573 unset MALLOC_CHECK_ MALLOC_PERTURB_
574 unset LD_PRELOAD GLIBC_TUNABLES
578 # Protect ourselves from common misconfiguration to export
579 # CDPATH into the environment
580 unset CDPATH
582 unset GREP_OPTIONS
583 unset UNZIP
585 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
586 1|2|true)
587 GIT_TRACE=4
589 esac
591 # Line feed
592 LF='
595 # Single quote
596 SQ=\'
598 # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores
599 # when case-folding filenames
600 u200c=$(printf '\342\200\214')
602 export _x05 _x35 LF u200c EMPTY_TREE EMPTY_BLOB ZERO_OID OID_REGEX
604 # Each test should start with something like this, after copyright notices:
606 # test_description='Description of this test...
607 # This test checks if command xyzzy does the right thing...
609 # . ./test-lib.sh
610 test "x$TERM" != "xdumb" && (
611 test -t 1 &&
612 tput bold >/dev/null 2>&1 &&
613 tput setaf 1 >/dev/null 2>&1 &&
614 tput sgr0 >/dev/null 2>&1
615 ) &&
616 color=t
618 if test -n "$color"
619 then
620 # Save the color control sequences now rather than run tput
621 # each time say_color() is called. This is done for two
622 # reasons:
623 # * TERM will be changed to dumb
624 # * HOME will be changed to a temporary directory and tput
625 # might need to read ~/.terminfo from the original HOME
626 # directory to get the control sequences
627 # Note: This approach assumes the control sequences don't end
628 # in a newline for any terminal of interest (command
629 # substitutions strip trailing newlines). Given that most
630 # (all?) terminals in common use are related to ECMA-48, this
631 # shouldn't be a problem.
632 say_color_error=$(tput bold; tput setaf 1) # bold red
633 say_color_skip=$(tput setaf 4) # blue
634 say_color_warn=$(tput setaf 3) # brown/yellow
635 say_color_pass=$(tput setaf 2) # green
636 say_color_info=$(tput setaf 6) # cyan
637 say_color_reset=$(tput sgr0)
638 say_color_="" # no formatting for normal text
639 say_color () {
640 test -z "$1" && test -n "$quiet" && return
641 eval "say_color_color=\$say_color_$1"
642 shift
643 printf "%s\\n" "$say_color_color$*$say_color_reset"
645 else
646 say_color() {
647 test -z "$1" && test -n "$quiet" && return
648 shift
649 printf "%s\n" "$*"
653 USER_TERM="$TERM"
654 TERM=dumb
655 export TERM USER_TERM
657 # What is written by tests to stdout and stderr is sent to different places
658 # depending on the test mode (e.g. /dev/null in non-verbose mode, piped to tee
659 # with --tee option, etc.). We save the original stdin to FD #6 and stdout and
660 # stderr to #5 and #7, so that the test framework can use them (e.g. for
661 # printing errors within the test framework) independently of the test mode.
662 exec 5>&1
663 exec 6<&0
664 exec 7>&2
666 _error_exit () {
667 finalize_junit_xml
668 GIT_EXIT_OK=t
669 exit 1
672 error () {
673 say_color error "error: $*"
674 _error_exit
677 BUG () {
678 error >&7 "bug in the test script: $*"
681 BAIL_OUT () {
682 test $# -ne 1 && BUG "1 param"
684 # Do not change "Bail out! " string. It's part of TAP syntax:
685 # https://testanything.org/tap-specification.html
686 local bail_out="Bail out! "
687 local message="$1"
689 say_color >&5 error $bail_out "$message"
690 _error_exit
693 say () {
694 say_color info "$*"
697 if test -n "$HARNESS_ACTIVE"
698 then
699 if test "$verbose" = t || test -n "$verbose_only"
700 then
701 BAIL_OUT 'verbose mode forbidden under TAP harness; try --verbose-log'
705 test "${test_description}" != "" ||
706 error "Test script did not set test_description."
708 if test "$help" = "t"
709 then
710 printf '%s\n' "$test_description"
711 exit 0
714 if test "$verbose_log" = "t"
715 then
716 exec 3>>"$GIT_TEST_TEE_OUTPUT_FILE" 4>&3
717 elif test "$verbose" = "t"
718 then
719 exec 4>&2 3>&1
720 else
721 exec 4>/dev/null 3>/dev/null
724 # Send any "-x" output directly to stderr to avoid polluting tests
725 # which capture stderr. We can do this unconditionally since it
726 # has no effect if tracing isn't turned on.
728 # Note that this sets up the trace fd as soon as we assign the variable, so it
729 # must come after the creation of descriptor 4 above. Likewise, we must never
730 # unset this, as it has the side effect of closing descriptor 4, which we
731 # use to show verbose tests to the user.
733 # Note also that we don't need or want to export it. The tracing is local to
734 # this shell, and we would not want to influence any shells we exec.
735 BASH_XTRACEFD=4
737 test_failure=0
738 test_count=0
739 test_fixed=0
740 test_broken=0
741 test_success=0
743 test_missing_prereq=
745 test_external_has_tap=0
747 die () {
748 code=$?
749 # This is responsible for running the atexit commands even when a
750 # test script run with '--immediate' fails, or when the user hits
751 # ctrl-C, i.e. when 'test_done' is not invoked at all.
752 test_atexit_handler || code=$?
753 if test -n "$GIT_EXIT_OK"
754 then
755 exit $code
756 else
757 echo >&5 "FATAL: Unexpected exit with code $code"
758 exit 1
762 GIT_EXIT_OK=
763 trap 'die' EXIT
764 # Disable '-x' tracing, because with some shells, notably dash, it
765 # prevents running the cleanup commands when a test script run with
766 # '--verbose-log -x' is interrupted.
767 trap '{ code=$?; set +x; } 2>/dev/null; exit $code' INT TERM HUP
769 # The user-facing functions are loaded from a separate file so that
770 # test_perf subshells can have them too
771 . "$TEST_DIRECTORY/test-lib-functions.sh"
773 # You are not expected to call test_ok_ and test_failure_ directly, use
774 # the test_expect_* functions instead.
776 test_ok_ () {
777 if test -n "$write_junit_xml"
778 then
779 write_junit_xml_testcase "$*"
781 test_success=$(($test_success + 1))
782 say_color "" "ok $test_count - $@"
785 test_failure_ () {
786 if test -n "$write_junit_xml"
787 then
788 junit_insert="<failure message=\"not ok $test_count -"
789 junit_insert="$junit_insert $(xml_attr_encode "$1")\">"
790 junit_insert="$junit_insert $(xml_attr_encode \
791 "$(if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
792 then
793 test-tool path-utils skip-n-bytes \
794 "$GIT_TEST_TEE_OUTPUT_FILE" $GIT_TEST_TEE_OFFSET
795 else
796 printf '%s\n' "$@" | sed 1d
797 fi)")"
798 junit_insert="$junit_insert</failure>"
799 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
800 then
801 junit_insert="$junit_insert<system-err>$(xml_attr_encode \
802 "$(cat "$GIT_TEST_TEE_OUTPUT_FILE")")</system-err>"
804 write_junit_xml_testcase "$1" " $junit_insert"
806 test_failure=$(($test_failure + 1))
807 say_color error "not ok $test_count - $1"
808 shift
809 printf '%s\n' "$*" | sed -e 's/^/# /'
810 if test -n "$immediate"
811 then
812 say_color error "1..$test_count"
813 _error_exit
817 test_known_broken_ok_ () {
818 if test -n "$write_junit_xml"
819 then
820 write_junit_xml_testcase "$* (breakage fixed)"
822 test_fixed=$(($test_fixed+1))
823 say_color error "ok $test_count - $@ # TODO known breakage vanished"
826 test_known_broken_failure_ () {
827 if test -n "$write_junit_xml"
828 then
829 write_junit_xml_testcase "$* (known breakage)"
831 test_broken=$(($test_broken+1))
832 say_color warn "not ok $test_count - $@ # TODO known breakage"
835 test_debug () {
836 test "$debug" = "" || eval "$1"
839 match_pattern_list () {
840 arg="$1"
841 shift
842 test -z "$*" && return 1
843 # We need to use "$*" to get field-splitting, but we want to
844 # disable globbing, since we are matching against an arbitrary
845 # $arg, not what's in the filesystem. Using "set -f" accomplishes
846 # that, but we must do it in a subshell to avoid impacting the
847 # rest of the script. The exit value of the subshell becomes
848 # the function's return value.
850 set -f
851 for pattern_ in $*
853 case "$arg" in
854 $pattern_)
855 exit 0
857 esac
858 done
859 exit 1
863 match_test_selector_list () {
864 operation="$1"
865 shift
866 title="$1"
867 shift
868 arg="$1"
869 shift
870 test -z "$1" && return 0
872 # Commas are accepted as separators.
873 OLDIFS=$IFS
874 IFS=','
875 set -- $1
876 IFS=$OLDIFS
878 # If the first selector is negative we include by default.
879 include=
880 case "$1" in
881 !*) include=t ;;
882 esac
884 for selector
886 orig_selector=$selector
888 positive=t
889 case "$selector" in
891 positive=
892 selector=${selector##?}
894 esac
896 test -z "$selector" && continue
898 case "$selector" in
899 *-*)
900 if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null
901 then
902 echo "error: $operation: invalid non-numeric in range" \
903 "start: '$orig_selector'" >&2
904 exit 1
906 if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null
907 then
908 echo "error: $operation: invalid non-numeric in range" \
909 "end: '$orig_selector'" >&2
910 exit 1
914 if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null
915 then
916 case "$title" in *${selector}*)
917 include=$positive
919 esac
920 continue
922 esac
924 # Short cut for "obvious" cases
925 test -z "$include" && test -z "$positive" && continue
926 test -n "$include" && test -n "$positive" && continue
928 case "$selector" in
930 if test $arg -le ${selector#-}
931 then
932 include=$positive
936 if test $arg -ge ${selector%-}
937 then
938 include=$positive
941 *-*)
942 if test ${selector%%-*} -le $arg \
943 && test $arg -le ${selector#*-}
944 then
945 include=$positive
949 if test $arg -eq $selector
950 then
951 include=$positive
954 esac
955 done
957 test -n "$include"
960 maybe_teardown_verbose () {
961 test -z "$verbose_only" && return
962 exec 4>/dev/null 3>/dev/null
963 verbose=
966 last_verbose=t
967 maybe_setup_verbose () {
968 test -z "$verbose_only" && return
969 if match_pattern_list $test_count "$verbose_only"
970 then
971 exec 4>&2 3>&1
972 # Emit a delimiting blank line when going from
973 # non-verbose to verbose. Within verbose mode the
974 # delimiter is printed by test_expect_*. The choice
975 # of the initial $last_verbose is such that before
976 # test 1, we do not print it.
977 test -z "$last_verbose" && echo >&3 ""
978 verbose=t
979 else
980 exec 4>/dev/null 3>/dev/null
981 verbose=
983 last_verbose=$verbose
986 maybe_teardown_valgrind () {
987 test -z "$GIT_VALGRIND" && return
988 GIT_VALGRIND_ENABLED=
991 maybe_setup_valgrind () {
992 test -z "$GIT_VALGRIND" && return
993 if test -z "$valgrind_only"
994 then
995 GIT_VALGRIND_ENABLED=t
996 return
998 GIT_VALGRIND_ENABLED=
999 if match_pattern_list $test_count "$valgrind_only"
1000 then
1001 GIT_VALGRIND_ENABLED=t
1005 trace_level_=0
1006 want_trace () {
1007 test "$trace" = t && {
1008 test "$verbose" = t || test "$verbose_log" = t
1012 # This is a separate function because some tests use
1013 # "return" to end a test_expect_success block early
1014 # (and we want to make sure we run any cleanup like
1015 # "set +x").
1016 test_eval_inner_ () {
1017 # Do not add anything extra (including LF) after '$*'
1018 eval "
1019 want_trace && trace_level_=$(($trace_level_+1)) && set -x
1023 test_eval_ () {
1024 # If "-x" tracing is in effect, then we want to avoid polluting stderr
1025 # with non-test commands. But once in "set -x" mode, we cannot prevent
1026 # the shell from printing the "set +x" to turn it off (nor the saving
1027 # of $? before that). But we can make sure that the output goes to
1028 # /dev/null.
1030 # There are a few subtleties here:
1032 # - we have to redirect descriptor 4 in addition to 2, to cover
1033 # BASH_XTRACEFD
1035 # - the actual eval has to come before the redirection block (since
1036 # it needs to see descriptor 4 to set up its stderr)
1038 # - likewise, any error message we print must be outside the block to
1039 # access descriptor 4
1041 # - checking $? has to come immediately after the eval, but it must
1042 # be _inside_ the block to avoid polluting the "set -x" output
1045 test_eval_inner_ "$@" </dev/null >&3 2>&4
1047 test_eval_ret_=$?
1048 if want_trace
1049 then
1050 test 1 = $trace_level_ && set +x
1051 trace_level_=$(($trace_level_-1))
1053 } 2>/dev/null 4>&2
1055 if test "$test_eval_ret_" != 0 && want_trace
1056 then
1057 say_color error >&4 "error: last command exited with \$?=$test_eval_ret_"
1059 return $test_eval_ret_
1062 test_run_ () {
1063 test_cleanup=:
1064 expecting_failure=$2
1066 if test "${GIT_TEST_CHAIN_LINT:-1}" != 0; then
1067 # turn off tracing for this test-eval, as it simply creates
1068 # confusing noise in the "-x" output
1069 trace_tmp=$trace
1070 trace=
1071 # 117 is magic because it is unlikely to match the exit
1072 # code of other programs
1073 if test "OK-117" != "$(test_eval_ "(exit 117) && $1${LF}${LF}echo OK-\$?" 3>&1)" ||
1075 test "${GIT_TEST_CHAIN_LINT_HARDER:-${GIT_TEST_CHAIN_LINT_HARDER_DEFAULT:-1}}" != 0 &&
1076 $(printf '%s\n' "$1" | sed -f "$GIT_BUILD_DIR/t/chainlint.sed" | grep -q '?![A-Z][A-Z]*?!')
1078 then
1079 BUG "broken &&-chain or run-away HERE-DOC: $1"
1081 trace=$trace_tmp
1084 setup_malloc_check
1085 test_eval_ "$1"
1086 eval_ret=$?
1087 teardown_malloc_check
1089 if test -z "$immediate" || test $eval_ret = 0 ||
1090 test -n "$expecting_failure" && test "$test_cleanup" != ":"
1091 then
1092 setup_malloc_check
1093 test_eval_ "$test_cleanup"
1094 teardown_malloc_check
1096 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
1097 then
1098 echo ""
1100 return "$eval_ret"
1103 test_start_ () {
1104 test_count=$(($test_count+1))
1105 maybe_setup_verbose
1106 maybe_setup_valgrind
1107 if test -n "$write_junit_xml"
1108 then
1109 junit_start=$(test-tool date getnanos)
1113 test_finish_ () {
1114 echo >&3 ""
1115 maybe_teardown_valgrind
1116 maybe_teardown_verbose
1117 if test -n "$GIT_TEST_TEE_OFFSET"
1118 then
1119 GIT_TEST_TEE_OFFSET=$(test-tool path-utils file-size \
1120 "$GIT_TEST_TEE_OUTPUT_FILE")
1124 test_skip () {
1125 to_skip=
1126 skipped_reason=
1127 if match_pattern_list $this_test.$test_count "$GIT_SKIP_TESTS"
1128 then
1129 to_skip=t
1130 skipped_reason="GIT_SKIP_TESTS"
1132 if test -z "$to_skip" && test -n "$run_list" &&
1133 ! match_test_selector_list '--run' "$1" $test_count "$run_list"
1134 then
1135 to_skip=t
1136 skipped_reason="--run"
1138 if test -z "$to_skip" && test -n "$test_prereq" &&
1139 ! test_have_prereq "$test_prereq"
1140 then
1141 to_skip=t
1143 of_prereq=
1144 if test "$missing_prereq" != "$test_prereq"
1145 then
1146 of_prereq=" of $test_prereq"
1148 skipped_reason="missing $missing_prereq${of_prereq}"
1150 # Keep a list of all the missing prereq for result aggregation
1151 if test -z "$missing_prereq"
1152 then
1153 test_missing_prereq=$missing_prereq
1154 else
1155 test_missing_prereq="$test_missing_prereq,$missing_prereq"
1159 case "$to_skip" in
1161 if test -n "$write_junit_xml"
1162 then
1163 message="$(xml_attr_encode "$skipped_reason")"
1164 write_junit_xml_testcase "$1" \
1165 " <skipped message=\"$message\" />"
1168 say_color skip "ok $test_count # skip $1 ($skipped_reason)"
1169 : true
1172 false
1174 esac
1177 # stub; perf-lib overrides it
1178 test_at_end_hook_ () {
1182 write_junit_xml () {
1183 case "$1" in
1184 --truncate)
1185 >"$junit_xml_path"
1186 junit_have_testcase=
1187 shift
1189 esac
1190 printf '%s\n' "$@" >>"$junit_xml_path"
1193 xml_attr_encode () {
1194 printf '%s\n' "$@" | test-tool xml-encode
1197 write_junit_xml_testcase () {
1198 junit_attrs="name=\"$(xml_attr_encode "$this_test.$test_count $1")\""
1199 shift
1200 junit_attrs="$junit_attrs classname=\"$this_test\""
1201 junit_attrs="$junit_attrs time=\"$(test-tool \
1202 date getnanos $junit_start)\""
1203 write_junit_xml "$(printf '%s\n' \
1204 " <testcase $junit_attrs>" "$@" " </testcase>")"
1205 junit_have_testcase=t
1208 finalize_junit_xml () {
1209 if test -n "$write_junit_xml" && test -n "$junit_xml_path"
1210 then
1211 test -n "$junit_have_testcase" || {
1212 junit_start=$(test-tool date getnanos)
1213 write_junit_xml_testcase "all tests skipped"
1216 # adjust the overall time
1217 junit_time=$(test-tool date getnanos $junit_suite_start)
1218 sed -e "s/\(<testsuite.*\) time=\"[^\"]*\"/\1/" \
1219 -e "s/<testsuite [^>]*/& time=\"$junit_time\"/" \
1220 -e '/^ *<\/testsuite/d' \
1221 <"$junit_xml_path" >"$junit_xml_path.new"
1222 mv "$junit_xml_path.new" "$junit_xml_path"
1224 write_junit_xml " </testsuite>" "</testsuites>"
1225 write_junit_xml=
1229 test_atexit_cleanup=:
1230 test_atexit_handler () {
1231 # In a succeeding test script 'test_atexit_handler' is invoked
1232 # twice: first from 'test_done', then from 'die' in the trap on
1233 # EXIT.
1234 # This condition and resetting 'test_atexit_cleanup' below makes
1235 # sure that the registered cleanup commands are run only once.
1236 test : != "$test_atexit_cleanup" || return 0
1238 setup_malloc_check
1239 test_eval_ "$test_atexit_cleanup"
1240 test_atexit_cleanup=:
1241 teardown_malloc_check
1244 test_done () {
1245 GIT_EXIT_OK=t
1247 # Run the atexit commands _before_ the trash directory is
1248 # removed, so the commands can access pidfiles and socket files.
1249 test_atexit_handler
1251 finalize_junit_xml
1253 if test -z "$HARNESS_ACTIVE"
1254 then
1255 mkdir -p "$TEST_RESULTS_DIR"
1257 cat >"$TEST_RESULTS_BASE.counts" <<-EOF
1258 total $test_count
1259 success $test_success
1260 fixed $test_fixed
1261 broken $test_broken
1262 failed $test_failure
1263 missing_prereq $test_missing_prereq
1268 if test "$test_fixed" != 0
1269 then
1270 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
1272 if test "$test_broken" != 0
1273 then
1274 say_color warn "# still have $test_broken known breakage(s)"
1276 if test "$test_broken" != 0 || test "$test_fixed" != 0
1277 then
1278 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
1279 msg="remaining $test_remaining test(s)"
1280 else
1281 test_remaining=$test_count
1282 msg="$test_count test(s)"
1284 case "$test_failure" in
1286 if test $test_external_has_tap -eq 0
1287 then
1288 if test $test_remaining -gt 0
1289 then
1290 say_color pass "# passed all $msg"
1293 # Maybe print SKIP message
1294 test -z "$skip_all" || skip_all="# SKIP $skip_all"
1295 case "$test_count" in
1297 say "1..$test_count${skip_all:+ $skip_all}"
1300 test -z "$skip_all" ||
1301 say_color warn "$skip_all"
1302 say "1..$test_count"
1304 esac
1307 if test -z "$debug" && test -n "$remove_trash"
1308 then
1309 test -d "$TRASH_DIRECTORY" ||
1310 error "Tests passed but trash directory already removed before test cleanup; aborting"
1312 cd "$TRASH_DIRECTORY/.." &&
1313 rm -fr "$TRASH_DIRECTORY" || {
1314 # try again in a bit
1315 sleep 5;
1316 rm -fr "$TRASH_DIRECTORY"
1317 } ||
1318 error "Tests passed but test cleanup failed; aborting"
1320 test_at_end_hook_
1322 exit 0 ;;
1325 if test $test_external_has_tap -eq 0
1326 then
1327 say_color error "# failed $test_failure among $msg"
1328 say "1..$test_count"
1331 exit 1 ;;
1333 esac
1336 if test -n "$valgrind"
1337 then
1338 make_symlink () {
1339 test -h "$2" &&
1340 test "$1" = "$(readlink "$2")" || {
1341 # be super paranoid
1342 if mkdir "$2".lock
1343 then
1344 rm -f "$2" &&
1345 ln -s "$1" "$2" &&
1346 rm -r "$2".lock
1347 else
1348 while test -d "$2".lock
1350 say "Waiting for lock on $2."
1351 sleep 1
1352 done
1357 make_valgrind_symlink () {
1358 # handle only executables, unless they are shell libraries that
1359 # need to be in the exec-path.
1360 test -x "$1" ||
1361 test "# " = "$(test_copy_bytes 2 <"$1")" ||
1362 return;
1364 base=$(basename "$1")
1365 case "$base" in
1366 test-*)
1367 symlink_target="$GIT_BUILD_DIR/t/helper/$base"
1370 symlink_target="$GIT_BUILD_DIR/$base"
1372 esac
1373 # do not override scripts
1374 if test -x "$symlink_target" &&
1375 test ! -d "$symlink_target" &&
1376 test "#!" != "$(test_copy_bytes 2 <"$symlink_target")"
1377 then
1378 symlink_target=../valgrind.sh
1380 case "$base" in
1381 *.sh|*.perl)
1382 symlink_target=../unprocessed-script
1383 esac
1384 # create the link, or replace it if it is out of date
1385 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1388 # override all git executables in TEST_DIRECTORY/..
1389 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1390 mkdir -p "$GIT_VALGRIND"/bin
1391 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/t/helper/test-*
1393 make_valgrind_symlink $file
1394 done
1395 # special-case the mergetools loadables
1396 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
1397 OLDIFS=$IFS
1398 IFS=:
1399 for path in $PATH
1401 ls "$path"/git-* 2> /dev/null |
1402 while read file
1404 make_valgrind_symlink "$file"
1405 done
1406 done
1407 IFS=$OLDIFS
1408 PATH=$GIT_VALGRIND/bin:$PATH
1409 GIT_EXEC_PATH=$GIT_VALGRIND/bin
1410 export GIT_VALGRIND
1411 GIT_VALGRIND_MODE="$valgrind"
1412 export GIT_VALGRIND_MODE
1413 GIT_VALGRIND_ENABLED=t
1414 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
1415 export GIT_VALGRIND_ENABLED
1416 elif test -n "$GIT_TEST_INSTALLED"
1417 then
1418 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
1419 error "Cannot run git from $GIT_TEST_INSTALLED."
1420 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR/t/helper:$PATH
1421 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
1422 else # normal case, use ../bin-wrappers only unless $with_dashes:
1423 if test -n "$no_bin_wrappers"
1424 then
1425 with_dashes=t
1426 else
1427 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1428 if ! test -x "$git_bin_dir/git"
1429 then
1430 if test -z "$with_dashes"
1431 then
1432 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
1434 with_dashes=t
1436 PATH="$git_bin_dir:$PATH"
1438 GIT_EXEC_PATH=$GIT_BUILD_DIR
1439 if test -n "$with_dashes"
1440 then
1441 PATH="$GIT_BUILD_DIR:$GIT_BUILD_DIR/t/helper:$PATH"
1444 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1445 GIT_CONFIG_NOSYSTEM=1
1446 GIT_ATTR_NOSYSTEM=1
1447 GIT_CEILING_DIRECTORIES="$TRASH_DIRECTORY/.."
1448 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM GIT_CEILING_DIRECTORIES
1450 if test -z "$GIT_TEST_CMP"
1451 then
1452 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1453 then
1454 GIT_TEST_CMP="$DIFF -c"
1455 else
1456 GIT_TEST_CMP="$DIFF -u"
1460 GITPERLLIB="$GIT_BUILD_DIR"/perl/build/lib
1461 export GITPERLLIB
1462 test -d "$GIT_BUILD_DIR"/templates/blt || {
1463 error "You haven't built things yet, have you?"
1466 if ! test -x "$GIT_BUILD_DIR"/t/helper/test-tool$X
1467 then
1468 echo >&2 'You need to build test-tool:'
1469 echo >&2 'Run "make t/helper/test-tool" in the source (toplevel) directory'
1470 exit 1
1473 # Are we running this test at all?
1474 remove_trash=
1475 this_test=${0##*/}
1476 this_test=${this_test%%-*}
1477 if match_pattern_list "$this_test" "$GIT_SKIP_TESTS"
1478 then
1479 say_color info >&3 "skipping test $this_test altogether"
1480 skip_all="skip all tests in $this_test"
1481 test_done
1484 # skip non-whitelisted tests when compiled with SANITIZE=leak
1485 if test -n "$SANITIZE_LEAK"
1486 then
1487 if test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1488 then
1489 # We need to see it in "git env--helper" (via
1490 # test_bool_env)
1491 export TEST_PASSES_SANITIZE_LEAK
1493 if ! test_bool_env TEST_PASSES_SANITIZE_LEAK false
1494 then
1495 skip_all="skipping $this_test under GIT_TEST_PASSING_SANITIZE_LEAK=true"
1496 test_done
1499 elif test_bool_env GIT_TEST_PASSING_SANITIZE_LEAK false
1500 then
1501 BAIL_OUT "GIT_TEST_PASSING_SANITIZE_LEAK=true has no effect except when compiled with SANITIZE=leak"
1504 # Last-minute variable setup
1505 USER_HOME="$HOME"
1506 HOME="$TRASH_DIRECTORY"
1507 GNUPGHOME="$HOME/gnupg-home-not-used"
1508 export HOME GNUPGHOME USER_HOME
1510 # "rm -rf" existing trash directory, even if a previous run left it
1511 # with bad permissions.
1512 remove_trash_directory () {
1513 dir="$1"
1514 if ! rm -rf "$dir" 2>/dev/null
1515 then
1516 chmod -R u+rwx "$dir"
1517 rm -rf "$dir"
1519 ! test -d "$dir"
1522 # Test repository
1523 remove_trash_directory "$TRASH_DIRECTORY" || {
1524 GIT_EXIT_OK=t
1525 echo >&5 "FATAL: Cannot prepare test area"
1526 exit 1
1529 remove_trash=t
1530 if test -z "$TEST_NO_CREATE_REPO"
1531 then
1532 git init "$TRASH_DIRECTORY" >&3 2>&4 ||
1533 error "cannot run git init"
1534 else
1535 mkdir -p "$TRASH_DIRECTORY"
1538 # Use -P to resolve symlinks in our working directory so that the cwd
1539 # in subprocesses like git equals our $PWD (for pathname comparisons).
1540 cd -P "$TRASH_DIRECTORY" || exit 1
1542 if test -n "$write_junit_xml"
1543 then
1544 junit_xml_dir="$TEST_OUTPUT_DIRECTORY/out"
1545 mkdir -p "$junit_xml_dir"
1546 junit_xml_base=${0##*/}
1547 junit_xml_path="$junit_xml_dir/TEST-${junit_xml_base%.sh}.xml"
1548 junit_attrs="name=\"${junit_xml_base%.sh}\""
1549 junit_attrs="$junit_attrs timestamp=\"$(TZ=UTC \
1550 date +%Y-%m-%dT%H:%M:%S)\""
1551 write_junit_xml --truncate "<testsuites>" " <testsuite $junit_attrs>"
1552 junit_suite_start=$(test-tool date getnanos)
1553 if test -n "$GIT_TEST_TEE_OUTPUT_FILE"
1554 then
1555 GIT_TEST_TEE_OFFSET=0
1559 # Convenience
1560 # A regexp to match 5 and 35 hexdigits
1561 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
1562 _x35="$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
1564 test_oid_init
1566 ZERO_OID=$(test_oid zero)
1567 OID_REGEX=$(echo $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1568 OIDPATH_REGEX=$(test_oid_to_path $ZERO_OID | sed -e 's/0/[0-9a-f]/g')
1569 EMPTY_TREE=$(test_oid empty_tree)
1570 EMPTY_BLOB=$(test_oid empty_blob)
1572 # Provide an implementation of the 'yes' utility; the upper bound
1573 # limit is there to help Windows that cannot stop this loop from
1574 # wasting cycles when the downstream stops reading, so do not be
1575 # tempted to turn it into an infinite loop. cf. 6129c930 ("test-lib:
1576 # limit the output of the yes utility", 2016-02-02)
1577 yes () {
1578 if test $# = 0
1579 then
1581 else
1582 y="$*"
1586 while test $i -lt 99
1588 echo "$y"
1589 i=$(($i+1))
1590 done
1593 # The GIT_TEST_FAIL_PREREQS code hooks into test_set_prereq(), and
1594 # thus needs to be set up really early, and set an internal variable
1595 # for convenience so the hot test_set_prereq() codepath doesn't need
1596 # to call "git env--helper" (via test_bool_env). Only do that work
1597 # if needed by seeing if GIT_TEST_FAIL_PREREQS is set at all.
1598 GIT_TEST_FAIL_PREREQS_INTERNAL=
1599 if test -n "$GIT_TEST_FAIL_PREREQS"
1600 then
1601 if test_bool_env GIT_TEST_FAIL_PREREQS false
1602 then
1603 GIT_TEST_FAIL_PREREQS_INTERNAL=true
1604 test_set_prereq FAIL_PREREQS
1606 else
1607 test_lazy_prereq FAIL_PREREQS '
1608 test_bool_env GIT_TEST_FAIL_PREREQS false
1612 # Fix some commands on Windows, and other OS-specific things
1613 uname_s=$(uname -s)
1614 case $uname_s in
1615 *MINGW*)
1616 # Windows has its own (incompatible) sort and find
1617 sort () {
1618 /usr/bin/sort "$@"
1620 find () {
1621 /usr/bin/find "$@"
1623 # git sees Windows-style pwd
1624 pwd () {
1625 builtin pwd -W
1627 # no POSIX permissions
1628 # backslashes in pathspec are converted to '/'
1629 # exec does not inherit the PID
1630 test_set_prereq MINGW
1631 test_set_prereq NATIVE_CRLF
1632 test_set_prereq SED_STRIPS_CR
1633 test_set_prereq GREP_STRIPS_CR
1634 test_set_prereq WINDOWS
1635 GIT_TEST_CMP=mingw_test_cmp
1637 *CYGWIN*)
1638 test_set_prereq POSIXPERM
1639 test_set_prereq EXECKEEPSPID
1640 test_set_prereq CYGWIN
1641 test_set_prereq SED_STRIPS_CR
1642 test_set_prereq GREP_STRIPS_CR
1643 test_set_prereq WINDOWS
1646 test_set_prereq POSIXPERM
1647 test_set_prereq BSLASHPSPEC
1648 test_set_prereq EXECKEEPSPID
1650 esac
1652 # Detect arches where a few things don't work
1653 uname_m=$(uname -m)
1654 case $uname_m in
1655 parisc* | hppa*)
1656 test_set_prereq HPPA
1658 esac
1660 test_set_prereq REFFILES
1662 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1663 test -z "$NO_PERL" && test_set_prereq PERL
1664 test -z "$NO_PTHREADS" && test_set_prereq PTHREADS
1665 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1666 test -n "$USE_LIBPCRE2" && test_set_prereq PCRE
1667 test -n "$USE_LIBPCRE2" && test_set_prereq LIBPCRE2
1668 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1669 test -n "$SANITIZE_LEAK" && test_set_prereq SANITIZE_LEAK
1671 if test -z "$GIT_TEST_CHECK_CACHE_TREE"
1672 then
1673 GIT_TEST_CHECK_CACHE_TREE=true
1674 export GIT_TEST_CHECK_CACHE_TREE
1677 test_lazy_prereq PIPE '
1678 # test whether the filesystem supports FIFOs
1679 test_have_prereq !MINGW,!CYGWIN &&
1680 rm -f testfifo && mkfifo testfifo
1683 test_lazy_prereq SYMLINKS '
1684 # test whether the filesystem supports symbolic links
1685 ln -s x y && test -h y
1688 test_lazy_prereq SYMLINKS_WINDOWS '
1689 # test whether symbolic links are enabled on Windows
1690 test_have_prereq MINGW &&
1691 cmd //c "mklink y x" &> /dev/null && test -h y
1694 test_lazy_prereq FILEMODE '
1695 test "$(git config --bool core.filemode)" = true
1698 test_lazy_prereq CASE_INSENSITIVE_FS '
1699 echo good >CamelCase &&
1700 echo bad >camelcase &&
1701 test "$(cat CamelCase)" != good
1704 test_lazy_prereq FUNNYNAMES '
1705 test_have_prereq !MINGW &&
1706 touch -- \
1707 "FUNNYNAMES tab embedded" \
1708 "FUNNYNAMES \"quote embedded\"" \
1709 "FUNNYNAMES newline
1710 embedded" 2>/dev/null &&
1711 rm -- \
1712 "FUNNYNAMES tab embedded" \
1713 "FUNNYNAMES \"quote embedded\"" \
1714 "FUNNYNAMES newline
1715 embedded" 2>/dev/null
1718 test_lazy_prereq UTF8_NFD_TO_NFC '
1719 # check whether FS converts nfd unicode to nfc
1720 auml=$(printf "\303\244")
1721 aumlcdiar=$(printf "\141\314\210")
1722 >"$auml" &&
1723 test -f "$aumlcdiar"
1726 test_lazy_prereq AUTOIDENT '
1727 sane_unset GIT_AUTHOR_NAME &&
1728 sane_unset GIT_AUTHOR_EMAIL &&
1729 git var GIT_AUTHOR_IDENT
1732 test_lazy_prereq EXPENSIVE '
1733 test -n "$GIT_TEST_LONG"
1736 test_lazy_prereq EXPENSIVE_ON_WINDOWS '
1737 test_have_prereq EXPENSIVE || test_have_prereq !MINGW,!CYGWIN
1740 test_lazy_prereq USR_BIN_TIME '
1741 test -x /usr/bin/time
1744 test_lazy_prereq NOT_ROOT '
1745 uid=$(id -u) &&
1746 test "$uid" != 0
1749 test_lazy_prereq JGIT '
1750 jgit --version
1753 # SANITY is about "can you correctly predict what the filesystem would
1754 # do by only looking at the permission bits of the files and
1755 # directories?" A typical example of !SANITY is running the test
1756 # suite as root, where a test may expect "chmod -r file && cat file"
1757 # to fail because file is supposed to be unreadable after a successful
1758 # chmod. In an environment (i.e. combination of what filesystem is
1759 # being used and who is running the tests) that lacks SANITY, you may
1760 # be able to delete or create a file when the containing directory
1761 # doesn't have write permissions, or access a file even if the
1762 # containing directory doesn't have read or execute permissions.
1764 test_lazy_prereq SANITY '
1765 mkdir SANETESTD.1 SANETESTD.2 &&
1767 chmod +w SANETESTD.1 SANETESTD.2 &&
1768 >SANETESTD.1/x 2>SANETESTD.2/x &&
1769 chmod -w SANETESTD.1 &&
1770 chmod -r SANETESTD.1/x &&
1771 chmod -rx SANETESTD.2 ||
1772 BUG "cannot prepare SANETESTD"
1774 ! test -r SANETESTD.1/x &&
1775 ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x
1776 status=$?
1778 chmod +rwx SANETESTD.1 SANETESTD.2 &&
1779 rm -rf SANETESTD.1 SANETESTD.2 ||
1780 BUG "cannot clean SANETESTD"
1781 return $status
1784 test FreeBSD != $uname_s || GIT_UNZIP=${GIT_UNZIP:-/usr/local/bin/unzip}
1785 GIT_UNZIP=${GIT_UNZIP:-unzip}
1786 test_lazy_prereq UNZIP '
1787 "$GIT_UNZIP" -v
1788 test $? -ne 127
1791 run_with_limited_cmdline () {
1792 (ulimit -s 128 && "$@")
1795 test_lazy_prereq CMDLINE_LIMIT '
1796 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1797 run_with_limited_cmdline true
1800 run_with_limited_stack () {
1801 (ulimit -s 128 && "$@")
1804 test_lazy_prereq ULIMIT_STACK_SIZE '
1805 test_have_prereq !HPPA,!MINGW,!CYGWIN &&
1806 run_with_limited_stack true
1809 run_with_limited_open_files () {
1810 (ulimit -n 32 && "$@")
1813 test_lazy_prereq ULIMIT_FILE_DESCRIPTORS '
1814 test_have_prereq !MINGW,!CYGWIN &&
1815 run_with_limited_open_files true
1818 build_option () {
1819 git version --build-options |
1820 sed -ne "s/^$1: //p"
1823 test_lazy_prereq SIZE_T_IS_64BIT '
1824 test 8 -eq "$(build_option sizeof-size_t)"
1827 test_lazy_prereq LONG_IS_64BIT '
1828 test 8 -le "$(build_option sizeof-long)"
1831 test_lazy_prereq TIME_IS_64BIT 'test-tool date is64bit'
1832 test_lazy_prereq TIME_T_IS_64BIT 'test-tool date time_t-is64bit'
1834 test_lazy_prereq CURL '
1835 curl --version
1838 # SHA1 is a test if the hash algorithm in use is SHA-1. This is both for tests
1839 # which will not work with other hash algorithms and tests that work but don't
1840 # test anything meaningful (e.g. special values which cause short collisions).
1841 test_lazy_prereq SHA1 '
1842 case "$GIT_DEFAULT_HASH" in
1843 sha1) true ;;
1844 "") test $(git hash-object /dev/null) = e69de29bb2d1d6434b8b29ae775ad8c2e48c5391 ;;
1845 *) false ;;
1846 esac
1849 # Ensure that no test accidentally triggers a Git command
1850 # that runs the actual maintenance scheduler, affecting a user's
1851 # system permanently.
1852 # Tests that verify the scheduler integration must set this locally
1853 # to avoid errors.
1854 GIT_TEST_MAINT_SCHEDULER="none:exit 1"
1856 # Does this platform support `git fsmonitor--daemon`
1858 test_lazy_prereq FSMONITOR_DAEMON '
1859 git version --build-options >output &&
1860 grep "feature: fsmonitor--daemon" output